package com.engine.xmgsecond.service.impl;

import com.engine.common.util.ServiceUtil;
import com.engine.core.impl.Service;
import com.engine.workflow.entity.publicApi.PAResponseEntity;
import com.engine.workflow.entity.publicApi.ReqOperateRequestEntity;
import com.engine.workflow.publicApi.WorkflowRequestOperatePA;
import com.engine.workflow.publicApi.impl.WorkflowRequestOperatePAImpl;
import com.engine.xmgsecond.entity.KqCloseSet;
import com.engine.xmgsecond.service.KqCloseAccountService;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2025/5/16 15:18
 * @Description: TODO
 * @Version 1.0
 */
public class KqCloseAccountServiceImpl extends Service implements KqCloseAccountService {

    private WorkflowRequestOperatePA getRequestOperatePA() {
        return ServiceUtil.getService(WorkflowRequestOperatePAImpl.class);
    }

    @Override
    public PAResponseEntity closeAccount(Map<String, Object> param) {

        String id = Util.null2String(param.get("billid"));
        String subCompanyIds = Util.null2String(param.get("gzfb"));
        String departmentIds = Util.null2String(param.get("gzbm"));
        String startDate = Util.null2String(param.get("ksrq"));
        String endDate = Util.null2String(param.get("jsrq"));


        RecordSet rs = new RecordSet();
        List<KqCloseSet> workflowList = getWorkflowList();
        WorkflowRequestOperatePA operatePA = getRequestOperatePA();

        //1.获取系统流程数据,根据关账流程配置中流程id


        //2.根据表单id,及配置字段参数,.获取分部or部门 开始日期和结束日期


        //3 值匹配筛选requestid


        //4.流程干预操作


        //5.更新关账记录表操作者信息





        ReqOperateRequestEntity requestParam = new ReqOperateRequestEntity();



        //流程干预
//        requestParam.setRequestId(1681681);
//        requestParam.setSrc("intervenor");
//        requestParam.setWorkflowId(95);
//        requestParam.setNodeId(392);
//        requestParam.setRemark("考勤干预");
//        requestParam.setEnableIntervenor(true);
//        requestParam.setSubmitNodeId(391);
//        requestParam.setIntervenorid("1");
//        PAResponseEntity paResponseEntity = operatePA.doIntervenor(user, requestParam);



        return null;
    }

    @Override
    public List<KqCloseSet> getWorkflowList() {

        List<KqCloseSet> kqCloseSets = new ArrayList<>();
        RecordSet rs = new RecordSet();
        rs.executeQuery("select id,lclj,ksrqdyzdbm,jsrqdyzdbm,ssfbdyzdbm,ssbmdyzdbm,fqjdid,gdjdid from uf_kqgzpz");
        while (rs.next()) {
            kqCloseSets.add(KqCloseSet.builder()
                    .id(Util.getIntValue(rs.getString("id")))
                    .workflowId(Util.getIntValue(rs.getString("lclj")))
                    .startDateCode(Util.null2String(rs.getString("ksrqdyzdbm")))
                    .endDateCode(Util.null2String(rs.getString("jsrqdyzdbm")))
                    .fbCode(Util.null2String(rs.getString("ssfbdyzdbm")))
                    .bmCode(Util.null2String(rs.getString("ssbmdyzdbm")))
                    .createNodeId(Util.getIntValue(rs.getString("fqjdid")))
                    .endNodeId(Util.getIntValue(rs.getString("gdjdid")))
                    .build());
        }
        return kqCloseSets;
    }

    @Override
    public Boolean checkSubmit(Map<String, Object> param) {

        String subCompanyIds = Util.null2String(param.get("subCompanyIds"));
        String departmentIds = Util.null2String(param.get("departmentIds"));
        String startDate = Util.null2String(param.get("startDate"));
        String endDate = Util.null2String(param.get("endDate"));

        boolean result = false;
        RecordSet rs = new RecordSet();

        String sql = "select id from uf_kqgzjl where ksrq <= ? and jsrq >= ?";

        if(!subCompanyIds.isEmpty()) {
            sql += " and gzfb is not null and gzfb in ("+subCompanyIds+")";
            rs.executeQuery(sql,endDate,startDate);
            result = rs.getCounts()>0;
        }

        if (!departmentIds.isEmpty() && !result) {
            sql += " and gzbm is not null and gzbm in ("+departmentIds+")";
            rs.executeQuery(sql,endDate,startDate);
            result = rs.getCounts()>0;
        }
        rs.writeLog("KqCloseAccountServiceImpl:checkSubmit"+sql);
        return result;
    }
}
